﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private clvtabs As CustomListView
	Private pncontent As Pane
	Private pnmain As Pane
	Public layoutsfolder As String
	Private ivtab As ImageView
	Private lbltabtext As Label
	Public ivfilelst As List = Array As String("maps-line-icon.png","map-pin-point-icon.png","route-arrows-up-icon.png","road-route-map-icon.png")
	Public tabslst As List = Array As String("Map","Points","Paths","Routes")
	Private tbtn1 As ToggleButton
	Private tbtn2 As ToggleButton
	Private pntab1 As Pane
	Private pntab2 As Pane
	Private pntab3 As Pane
	Private pntab4 As Pane
	Public clickcnt As Int = 1
	Public pointcnt As Int = 0
	Public x1,x2,y1,y2 As Float
	Public pointlst As List
	Public pointpathlst As List
	Private tbtn3 As ToggleButton
	Private tbtn4 As ToggleButton
	Public selectedpoint As point
	Private lblpoint As Label
	Public srcpoint As point
	Public destpoint As point
	Public routeclick As Int = 1
	Public startpoint As point
	Public endpoint As point
	Public maxval As Int = 99999
	Public maxpoints As Int = 1000
	Public graph(maxpoints,maxpoints) As Int
	Private btnloadmap As Button
	Private talogs As TextArea
	Private tbtnshowlogs As ToggleButton
	Public fchoose As FileChooser
	Private btnsnapshot As Button
	Private btnreset As Button
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Shortest distance")
	clvtabs.Clear
	For i = 0 To tabslst.Size - 1
		Dim p As Pane = set_clvtabs_item(i+1)
		clvtabs.Add(p,"tab" & (i+1))
	Next
	pntab1.Initialize("")
	pntab1.Tag = ""
	pntab2.Initialize("")
	pntab2.Tag = ""
	pntab3.Initialize("")
	pntab3.Tag = ""
	pntab4.Initialize("")
	pntab4.Tag = ""
	pointlst.Initialize
	pointpathlst.Initialize
	For x = 0 To maxpoints -1
		For y = 0 To maxpoints - 1
			graph(x,y) = 0
		Next
	Next
	lblpoint.As(B4XView).SendToBack
	tbtnshowlogs.Text = "Hide logs"
	tbtnshowlogs.Selected = False
	fchoose.Initialize
End Sub

Private Sub set_clvtabs_item(index As Int) As Pane
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0,0dip,0dip,clvtabs.AsView.Width,50dip)
	p.LoadLayout("clvtabsitem_layout")
	lbltabtext.Text = tabslst.get(index-1)
	Dim bmp As Image = fx.LoadImage(File.DirAssets,ivfilelst.Get(index-1))
	ivtab.SetImage(bmp)
	Return p
End Sub

Private Sub clvtabs_ItemClick (Index As Int, Value As Object)
	For i = 0 To clvtabs.Size - 1
		clvtabs.GetPanel(i).GetView(0).Color = xui.Color_LightGray
	Next
	clvtabs.GetPanel(Index).GetView(0).Color = xui.Color_ARGB(255,178,178,239)
	pncontent.RequestFocus
	pntab1.As(B4XView).SendToBack
	Select Index
		Case 0
			If pntab1.Tag = "" Then
				pntab1 = set_content(Index+1)
				pntab1.Tag = "pane" & (Index+1)
				pncontent.AddNode(pntab1,0,0,pncontent.PrefWidth,pncontent.PrefHeight)
			End If
			pntab1.Visible = True
			pntab1.As(B4XView).BringToFront
			tbtn1.Text = "Hide map"
			tbtn1.Selected = False
		Case 1
			If pntab2.Tag = "" Then
				pntab2 = set_content(Index+1)
				pntab2.Tag = "pane" & (Index+1)
				pncontent.AddNode(pntab2,0,0,pncontent.PrefWidth,pncontent.PrefHeight)
			End If
			pntab2.Visible = True
			pntab2.As(B4XView).BringToFront
			tbtn2.Text = "Hide points"
			tbtn2.Selected = False
		Case 2
			If pntab3.Tag = "" Then
				pntab3 = set_content(Index+1)
				pntab3.Tag = "pane" & (Index+1)
				pncontent.AddNode(pntab3,0,0,pncontent.PrefWidth,pncontent.PrefHeight)
			End If
			pntab3.Visible = True
			pntab3.As(B4XView).BringToFront
			tbtn3.Text = "Hide paths"
			tbtn3.Selected = False
		Case 3
			If pntab4.Tag = "" Then
				pntab4.RemoveNodeFromParent
				pntab4 = set_content(Index+1)
				pntab4.Tag = "pane" & (Index+1)
				pncontent.AddNode(pntab4,0,0,pncontent.PrefWidth,pncontent.PrefHeight)
			End If
			pntab4.Visible = True
			pntab4.As(B4XView).BringToFront
			tbtn4.Text = "Hide route"
			tbtn4.Selected = False
			routeclick = 1
			pntab4.Tag = ""
	End Select
End Sub

Private Sub set_content(index As Int) As Pane
	Dim pn As B4XView = xui.CreatePanel("")
	pn.SetLayoutAnimated(0,0dip,0dip,pncontent.PrefWidth,pncontent.PrefHeight)
	pn.LoadLayout("tab" & index & "_layout")
	pn.SetColorAndBorder(xui.Color_Transparent,0,0,0)
	Return pn
End Sub

Private Sub pncontent_Touch (Action As Int, X As Float, Y As Float)
	Dim pn As Pane = Sender
	Log(pn.Tag)
End Sub
Private Sub tbtn1_SelectedChange(Selected As Boolean)
	If Selected Then
		pntab1.Visible = False
		tbtn1.Text = "Show map"
	Else
		pntab1.Visible = True
		tbtn1.Text = "Hide map"
	End If
End Sub
Private Sub tbtn2_SelectedChange(Selected As Boolean)
	If Selected Then
		pntab2.Visible = False
		tbtn2.Text = "Show points"
	Else
		pntab2.Visible = True
		tbtn2.Text = "Hide points"
	End If	
End Sub
Private Sub tbtn3_SelectedChange(Selected As Boolean)
	If Selected Then
		pntab3.Visible = False
		tbtn3.Text = "Show paths"
	Else
		pntab3.Visible = True
		tbtn3.Text = "Hide paths"
	End If
End Sub
Private Sub tbtn4_SelectedChange(Selected As Boolean)
	If Selected Then
		pntab4.Visible = False
		tbtn4.Text = "Show route"
	Else
		pntab4.Visible = True
		tbtn4.Text = "Hide route"
	End If
End Sub
Private Sub tbtnshowlogs_SelectedChange(Selected As Boolean)
	If Selected Then
		talogs.Visible = False
		'talogs.As(B4XView).SendToBack
		tbtnshowlogs.Text = "Show logs"
	Else
		talogs.Visible = True
		talogs.As(B4XView).BringToFront
		tbtnshowlogs.Text = "Hide logs"
		show_lists
	End If
	
End Sub

Private Sub pntab1_Touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		' using the designer tab1_layout
	End If
End Sub
Private Sub pntab2_Touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		If check_point_area(X,Y) = False Then
			Dim pnt As point
			Dim cnvs As B4XCanvas
			cnvs.Initialize(pntab2)
			pnt.xpos = X
			pnt.ypos = Y
			pnt.num = pointcnt		' starting at 0
			'pnt.visited = False
			pointlst.Add(pnt)
			draw_point(pnt,cnvs)
			pointcnt = pointcnt + 1
		End If
	End If
End Sub
Private Sub pntab3_Touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		Dim cnvs As B4XCanvas
		cnvs.Initialize(pntab3)
		If clickcnt = 1 Then
			If check_point_area(X,Y) = True Then
				lblpoint.Text = " Num: " & selectedpoint.num & "  X: " & selectedpoint.xpos & "  Y: " & selectedpoint.ypos
				srcpoint = selectedpoint
				clickcnt = 2
			End If
		Else
			If clickcnt = 2 Then
				If check_point_area(X,Y) = True Then
					lblpoint.Text = " Num: " & selectedpoint.num & "  X: " & selectedpoint.xpos & "  Y: " & selectedpoint.ypos
					destpoint = selectedpoint
					If srcpoint.num <> destpoint.num Then
						If path_exists(srcpoint,destpoint) = False Then
							Dim pntpath As pointpath
							Dim distance As Double = calculate_distance(srcpoint,destpoint)
							pntpath.src = srcpoint.num
							pntpath.dest = destpoint.num
							pntpath.distance = Round(distance)
							'pntpath.shortest = False
							lblpoint.Text = lblpoint.Text & "  D: " & Round(distance)
							If srcpoint.num < destpoint.num Then
								pointpathlst.Add(pntpath)								
							Else
								pntpath.src = destpoint.num
								pntpath.dest = srcpoint.num
								pointpathlst.Add(pntpath)
							End If
							graph(srcpoint.num,destpoint.num) = pntpath.distance
							graph(destpoint.num,srcpoint.num) = pntpath.distance
							draw_path(srcpoint,destpoint,cnvs,xui.Color_ARGB(255,141,255,130),3)
							draw_text(srcpoint,destpoint,cnvs,distance)
							clickcnt = 1
						End If
					End If
				End If
			End If
		End If
	End If
End Sub
Private Sub pntab4_Touch (Action As Int, X As Float, Y As Float)
	If Action = 0 Then
		If pointpathlst.Size = 0 Then
			xui.MsgboxAsync("Select the paths first!","Route")
			Return
		End If
		Dim cnvs As B4XCanvas
		cnvs.Initialize(pntab4)
		If routeclick = 1 Then
			If check_point_area(X,Y) = True Then
				startpoint = selectedpoint
				cnvs.DrawCircle(X,Y,15,xui.Color_Blue,True,1)
				cnvs.Invalidate
				routeclick = 2
			End If
		Else
			If routeclick = 2 Then
				If check_point_area(X,Y) = True Then
					endpoint = selectedpoint
					cnvs.DrawCircle(X,Y,15,xui.Color_Green,True,1)
					cnvs.Invalidate
					routeclick = 0
					show_lists
					shortest_distance
				End If
			End If			
		End If
	End If
End Sub

Private Sub calculate_distance(pnt1 As point, pnt2 As point) As Double
	Return Sqrt(Power(pnt2.xpos-pnt1.xpos,2)+Power(pnt2.ypos-pnt1.ypos,2))
End Sub
Private Sub draw_point(pnt As point, canv As B4XCanvas)
	canv.DrawCircle(pnt.xpos,pnt.ypos,7,xui.Color_Blue,True,2)
	canv.DrawCircle(pnt.xpos,pnt.ypos,15,xui.Color_Black,False,1)
	canv.DrawText(pointlst.size-1,pnt.xpos+25,pnt.ypos+20,xui.CreateDefaultFont(12),xui.Color_Black,"RIGHT")
	canv.Invalidate
End Sub
Private Sub draw_path(pnt1 As point, pnt2 As point, canv As B4XCanvas, color As Int,thick As Int)
	canv.DrawLine(pnt1.xpos,pnt1.ypos,pnt2.xpos,pnt2.ypos,color,thick)
	canv.Invalidate
End Sub
Private Sub draw_text(pnt1 As point, pnt2 As point, canv As B4XCanvas,dist As Double)
	Dim rx As Float = (pnt2.xpos+pnt1.xpos)/2
	Dim ry As Float = (pnt2.ypos+pnt1.ypos)/2
	Dim fnt As B4XFont = fx.CreateFont("Verdana",15,True,True)
	canv.DrawText(Round(dist),rx,ry,fnt,xui.Color_Black,"CENTER")
	canv.Invalidate
End Sub
Private Sub draw_bitmap(pn As Pane, canv As B4XCanvas, imgurl As String, fname As String)
	Dim rect As B4XRect
	rect.Width = pn.PrefWidth
	rect.Height = pn.PrefHeight
	Dim bmp As Image
	If imgurl = "" Then
		bmp.Initialize(File.DirAssets, "bitmap.png")	
	Else
		bmp.Initialize(imgurl, fname)
	End If
	canv.DrawBitmap(bmp, rect)
	canv.Invalidate
End Sub	

Private Sub check_point_area(x As Float, y As Float) As Boolean
	For i = 0 To pointlst.Size -1
		Dim pnt As point = pointlst.Get(i)
		If (pnt.xpos >= x-10) And (pnt.xpos <= x+10) And (pnt.ypos >= y-10) And (pnt.ypos <= y+10) Then
			selectedpoint = pnt
			Return True
		End If
	Next
	Return False
End Sub
Private Sub path_exists(pnt1 As point, pnt2 As point) As Boolean
	For i = 0 To pointpathlst.Size -1
		Dim ppath As pointpath = pointpathlst.Get(i)
		If ppath.src = pnt1.num And ppath.dest = pnt2.num Then
			Return True
		End If
		If ppath.dest = pnt1.num And ppath.src = pnt2.num Then
			Return True
		End If
	Next
	Return False
End Sub

Private Sub show_lists
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(talogs.Text).Append(CRLF)
	Log("points:")
	sb.Append("points:").Append(CRLF)
	For i = 0 To pointlst.Size -1
		Dim pnt As point = pointlst.Get(i)
		Log(pnt.num & " " & pnt.xpos & " " & pnt.ypos)	' & " " & pnt.visited)
		sb.Append(pnt.num & " " & pnt.xpos & " " & pnt.ypos).Append(CRLF)
	Next
	Log("paths:")
	sb.Append("paths:").Append(CRLF)
	For i = 0 To pointpathlst.Size -1
		Dim ppath As pointpath = pointpathlst.Get(i)
		Log(ppath.src & " " & ppath.dest & " " & ppath.distance.As(String))	' & " " & ppath.shortest)
		sb.Append(ppath.src & " " & ppath.dest & " " & ppath.distance.As(String)).Append(CRLF)
	Next
	Log("graph:")
	sb.Append("graph:").Append(CRLF)
	For x = 0 To pointcnt -1
		For y = 0 To pointcnt - 1
			If graph(x,y) <> 0 Then
				Log("graph(" & x & "," & y & ") = " & graph(x,y))
				sb.Append("graph(" & x & "," & y & ") = " & graph(x,y)).Append(CRLF)
			End If
		Next
	Next
	sb.Append(CRLF)
	talogs.Text = sb
End Sub

Private Sub shortest_distance
	' https://www.geeksforgeeks.org/dijkstras-shortest-path-algorithm-greedy-algo-7/
	' source number
	Dim src As Int = startpoint.num
	' init arrays
	Dim dist(pointcnt) As Int
	Dim shortset(pointcnt) As Boolean
	Dim parent(pointcnt) As Int
	For i = 0 To pointcnt -1
		dist(i) = maxval
		shortset(i) = False
	Next
	dist(src) = 0
	For cnt = 0 To pointcnt -1
		Dim mi As Int = min_distance(dist,shortset)
		shortset(mi) = True
		For i = 0 To pointcnt -1
			If shortset(i) = False And graph(mi,i) <> 0 And dist(mi) <> maxval And (dist(mi) + graph(mi,i) < dist(i)) Then
				dist(i) = dist(mi) + graph(mi,i)
				parent(i) = mi
			End If
		Next	
	Next
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(talogs.text).Append(CRLF)
	' show result lists
	Log("Shortest distances: ")
	sb.Append("Shortest distances: ").Append(CRLF)
	For i = 0 To pointcnt -1
		Log(i & " " & dist(i))
		sb.Append(i & " " & dist(i)).Append(CRLF)
	Next
	Log("parents: ")
	sb.Append("parents: ").Append(CRLF)
	For i = 0 To pointcnt -1
		Log(i & " " & parent(i))
		sb.Append(i & " " & parent(i)).Append(CRLF)
	Next
	talogs.Text = sb
	draw_shortest_path(dist,parent,xui.Color_Red,5)
End Sub
Private Sub min_distance(dist() As Int,shortset() As Boolean) As Int
	Dim mindist As Int = maxval
	Dim min_index As Int = -1
	For i = 0 To pointcnt -1
		If shortset(i) = False And dist(i) <= mindist Then
			mindist = dist(i)
			min_index = i 
		End If
	Next
	Return min_index
End Sub
Private Sub draw_shortest_path(dist() As Int, parent() As Int, color As Int, thick As Int)
	Dim cnvs As B4XCanvas
	cnvs.Initialize(pntab4)
	Dim parentnum As Int
	Dim pnt As point
	parentnum = parent(endpoint.num)		' backtracking from the endpoint
	pnt = pointlst.get(parentnum)
	draw_path(endpoint, pnt, cnvs, color, thick)
	Dim currpnt As point
	currpnt = pnt
	Do While currpnt <> startpoint
		parentnum = parent(currpnt.num)
		pnt = pointlst.get(parentnum)
		draw_path(currpnt, pnt, cnvs, color,thick)
		currpnt = pnt
	Loop
End Sub

Private Sub reset_app
	pntab1.Tag = ""
	pntab1.RemoveNodeFromParent
	pntab2.Tag = ""
	pntab2.RemoveNodeFromParent
	pntab3.Tag = ""
	pntab3.RemoveNodeFromParent
	pntab4.Tag = ""
	pntab4.RemoveNodeFromParent
	pointlst.Initialize
	pointpathlst.Initialize
	For x = 0 To maxpoints -1
		For y = 0 To maxpoints - 1
			graph(x,y) = 0
		Next
	Next
	pointcnt = 0
	routeclick = 1
	talogs.Text = ""
	lblpoint.Text = ""
End Sub

Private Sub btnloadmap_Click
	If pointlst.Size > 0 Then
		Dim rs As Object = xui.Msgbox2Async("This will reset the application. Continue?", "Load map", "Yes", "Cancel", "No", Null)
		Wait For (rs) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			reset_app
		Else
			Return
		End If
	Else
		reset_app
	End If
	' load an image file in pntab1
	pntab1 = set_content(1)
	pntab1.Tag = "pane" & (1)
	pncontent.AddNode(pntab1,0,0,pncontent.PrefWidth,pncontent.PrefHeight)
	Dim cnvs As B4XCanvas
	cnvs.Initialize(pntab1)
	fchoose.setExtensionFilter("Image", Array As String("*.jpg","*.png"))
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename <> "" Then
		Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
		filename = filename.SubString(filename.LastIndexOf("\")+1)
		draw_bitmap(pntab1,cnvs,filepath,filename)
		cnvs.Invalidate
	End If
	pntab1.As(B4XView).SendToBack
End Sub

Private Sub btnsnapshot_Click
	Dim snap As B4XBitmap = pncontent.Snapshot		' from pnmain includes the tabs
	fchoose.setExtensionFilter("Image", Array As String("*.png"))
	Dim filename As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename <> "" Then
		Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
		filename = filename.SubString(filename.LastIndexOf("\")+1)		
		Dim bmp As B4XBitmap = snap
		Dim out As OutputStream
		out = File.OpenOutput(filepath, filename, False)
		bmp.WriteToStream(out, 100, "PNG")
		out.Close
	End If
End Sub

Private Sub btnreset_Click
	Dim rs As Object = xui.Msgbox2Async("This will reset the application. Continue?", "Reset", "Yes", "Cancel", "No", Null)
	Wait For (rs) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		reset_app
	Else
		Return
	End If
End Sub